#ifndef EMITSIGNAL_H_
#define EMITSIGNAL_H_

#include "marshall.h"
#include "zend.h"

class MocArgument;
class QObject;

class EmitSignal : public Marshall
{
public:
	EmitSignal(QObject *obj, const int id, const int items, MocArgument* mocStack, zval **sp, zval * result);
	virtual ~EmitSignal();
    Marshall::Action action();
    Smoke::StackItem &item();
	const char *mytype();
	void emitSignal();
	void mainfunction();
	bool cleanup();
	void next();
	SmokeType type();
	zval* var();
	void unsupported();
	Smoke* smoke();
	const MocArgument &arg();
	bool doAlloc() { return false; }

 protected:
	MocArgument *_args;
	int _cur;
	bool _called;
	Smoke::Stack _stack;
	int _items;
	zval **_sp;
	QObject* _obj;
	int _id;
	zval* _result;
};

#endif /*EMITSIGNAL_H_*/

